#include "globals.h"
#include "battery.h"
#include "panel.h"
#include "sleep.h"
#include "timer.h"

#ifdef BATTERY_SHOW
#include "bargraph.h"
#endif 

static bool battery_err = false;

bool
battery_geterr(void)
{
	register bool x = battery_err;
	battery_err = false;
	return x;
}

/* vraci word -- hodnotu a/d prevodniku na kterem je pripojeno napajeni */
word
battery_status(void)
{
	register word retval;

	BATPORT = 1; /* Analogovy pristup */
	
	IO_ADCS0.bit.MD = 0; /* Mod -- single */
	IO_ADCS0.bit.ANS = BATPIN; /* Start pin */
	IO_ADCS0.bit.ANE = BATPIN; /* End pin */

	IO_ADCS1.bit.BUSY = 0; /* Terminate */
	IO_ADCS1.bit.INTE = 0; /* No interrupts */
	IO_ADCS1.bit.STS = 0; /* Software activation */

	IO_ADCR01.byte.ADCR1 = 0x60; /* 10 bit, 4096 cycles sampling, 176 cycles comparing */

	IO_ADCS1.bit.STRT = 1; /* Odstartujem */
	while(IO_ADCS1.bit.BUSY); /* Pockame do konce prevodu */
	retval = IO_ADCR01.DATA10;

	BATPORT = 0; /* zpatky do IO rezimu, vstup */
	IO_DDR6.bit.D67 = 0;

	return retval;
}

bool
battery_test(byte row)
{
	register word adval;

	adval = battery_status();
	if (adval > BATTERY_CHARGED) 
		return battery_err = false;
	else if (adval > BATTERY_DISCHARGED) {
		p_mvputs(0, row, "Baterie temer vybite");
		return battery_err = true;
	} else {
		p_clear();
		p_mvputs(0, row, "Baterie jsou vybite!");
		IO_PDR7.bit.P75 = 0; /* vypnu podsviceni displeje */
		go_stop(true); /* a navzdy usnu */
	}
	return true == false; /* jen pro prekladac .. */
}

#ifdef BATTERY_SHOW
word
battery_show(void *foo)
{
	register word adval;
	struct bargraph b;
	
	UNUSED_ARG(foo);

	p_putscreen(
			"Baterie plne z xxx %\n"
			"\n"
			"\n"
			"Stiskni lib. klavesu", true);
	bargraph_new(&b, 0, 19, 1);
	p_setcursor(C_NONE);
	while(p_getkey() == K_NONE) {
		adval = battery_status();
		if (adval < BATTERY_DISCHARGED)
			adval = BATTERY_DISCHARGED;
		if (adval > BATTERY_MAX)
			adval = BATTERY_MAX;
		bargraph_update(&b, 
				((adval - BATTERY_DISCHARGED)<<8)/(BATTERY_MAX - BATTERY_DISCHARGED)
				);
		p_move(15, 0);
		p_putidf(((adval - BATTERY_DISCHARGED)*100)/(BATTERY_MAX - BATTERY_DISCHARGED), 3);
#ifdef BATTERY_CALIBRATION
		p_move(0, 1); p_putidf(battery_status(), 5);
#endif 
		jsleep(100);
		battery_test(1);
	}
	p_setcursor(C_BLOCK);
	return 0;
}
#endif /* BATTERY_SHOW */
