/* 
 * Changelog:
 * 2005-08-03 pridano strncmp()
 * 2006-12-11 smazano memmove, memset, jsou v string.h
 */

#ifndef _BLOCK_H_
#define _BLOCK_H_

#include "globals.h"

#ifndef __GNUC__

#define DONT_BLOCK_USE_STRNCPYX
#define DONT_BLOCK_USE_STRNCMP /* v <string.h> ?? */
#define BLOCK_USE_STRCASECMP

/* Kopiruje az n znaku ze src do dest. Na rozdil od strcpy
 * vzdy v dest bude na poslednim miste ukoncovaci nula ('\0').
 */
char*
strncpyx(char *dest, const char *src, size_t n);

/* ANSI strncmp, pomale a male */
int
strncmp(const char *a, const char *b, size_t n);
	
/* strcasecmp pomoci tolower, ANSI compliance nezarucena */
int
strcasecmp(const char *a, const char *b);

#else
#include <string.h>

#endif /* __GNUC__ */

#endif /* _BLOCK_H_ */
