/*
 * globals.h
 *
 * Globalni promene, deklarace typu, uzitecna makra apod.
 *
 */

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#ifndef __GNUC__

#ifndef _MB90595_H_
#define _MB90595_H_
#include<sample\_mb90595.h>
#endif 

#define DEVEL_VERSION

#define VER_NAME "SeisRec"
#define VER_NUM "1.00"
#define VER_DATE "2004-08-31"

#define NAPALM_TEXT		VER_NAME
#define NAPALM_LEN		sizeof(NAPALM_TEXT)

/* Nazev projektu */
#define PROJECT_GRMETR

/* Jak rychlej mame krystal ? */
//#define XTAL73728
#define XTAL80000

#endif /* GNUC */

#ifdef __GNUC__
typedef unsigned char	byte;
typedef unsigned short	uint16;
typedef unsigned int	uint32;
#else
typedef unsigned char	byte;
typedef unsigned int	uint16;
typedef unsigned long	uint32;
#endif 

/* Nepouzivane argumenty lze obalit makrem UNUSED_ARG, nebudou hazet warningy.
 * Totez plati pro nepouzita navesti a makro UNUSED_LABEL. */
#ifdef DEVEL_VERSION
#define UNUSED_ARG(_x) {if(_x);}
#define UNUSED_LABEL(_x) {if(0) goto _x;}
#else
#define UNUSED_ARG(_x)
#define UNUSED_LABEL(_x)
#endif

typedef unsigned char	bool;
#define true (bool)1
#define false (bool)0


#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define ABS(a) ((a) < 0 ? (-(a)) : (a))
#define SGN(a) ((a) > 0 ? 1 : (a) < 0 ? -1 : 0)
#define isnum(a) ((a)>='0' && (a)<='9')

#ifndef __GNUC_

#ifndef NULL
#define NULL ((void *)0)
#endif 

#ifndef EOF
#define EOF ((int)-1)
#endif

		/* Podpora gosub v C-cku, doufam ze funguje :-)
		 * pouziti:
		 * 
		 * blabalbal;
		 * 
		 * gosub(doom)
		 * 
		 * blablabla;
		 * 
		 * label(doom);
		 * 	babsaj;
		 * 	snkasna;
		 * retsub;
		 */
typedef unsigned int label_t;
/* Skace na label _x, nutny navrat pomoci retsub */
#define gosub(_x) 				__asm(" CALL	L_"#_x)
/* Skace na hodnotu ulozenou v promenne _x (16tibitova), nutny navrat 
 * pomoci retsub */
#define gosubvar(_x)			__asm(" CALL	@_"#_x)
/* Jako gosubvar, ale neni mozny navrat pomoci retsub. */
#define gotovar(_x)			__asm(" JMP 	@_"#_x)
/* Ulozi do _dst adresu labelu _src, na _dst je pozdeji mozno skakat 
 * pomoci gosubvar */
#define savelabel(_dst, _src)	__asm(" MOVW	_"#_dst", #L_"#_src);
/* Vraci se z gosub* */
#define retsub __asm(" RET")

#ifdef DEVEL_VERSION
/* Vytvori label pro pouziti gosub* a savelabel */
#define label(_x) /*_x:*/__asm(" L_"#_x":");
#else
#define label(_x) __asm(" L_"#_x":");
#endif

#endif /* __GNUC_ */

#endif /* _GLOBALS_H_ */
