#include "globals.h"
#include "keybint.h"
#include "panel.h"
#include "timer.h"
#include "buzzer.h"
#include "uart.h"

/*
 * prozatim (k 10.9.2003) ma 
 * UART IL = 6
 * support_int IL = 5
 * buzzer_int  IL = 4
 */


/* obsluha vyjimek (rozsvitim nejake LEDky) */
__interrupt void except(void)
{
	IO_DDR8.byte |= 0xf;
	IO_PDR8.byte |= 0xf;
	for(;;);
}
/* vyjimky (jeste nikdy jsem nevidel v praxi :-) */
#pragma intvect except 10

/* ppg 0/1 */
#pragma intvect support_int	22 

/* ppg a/b */
#pragma intvect buzzer_int	34

/* klavesnice */
#pragma intvect keybint 13 /* ext. int. 0/1 */
#pragma intvect keybint 18 /* ext. int. 2/3 */
#pragma intvect keybint 20 /* ext. int. 4/5 */
#pragma intvect keybint 25 /* ext. int. 6/7 */

/* seriak 0 */
#ifdef UART0
__interrupt void uart0rx(void);
__interrupt void uart0tx(void);
#pragma intvect uart0rx 37
#pragma intvect uart0tx 38
#endif

/* seriak 1 */
#ifdef UART1
__interrupt void uart1rx(void);
__interrupt void uart1tx(void);
#pragma intvect uart1rx 39
#pragma intvect uart1tx 40
#endif
