#include <string.h>
#include "globals.h"
#include "misc.h"
#include "num2str.h"
#include "rtc.h"

/* Changelog
 *
 * 2006-10-11: Includuju <string.h> misto "block.h"
 */

void
p_msg(const char *txt)
{
	p_scrollup();
	p_mvputs(0, P_ROWS - 1, txt);
}

void
p_scrollup(void)
{
	register int i;
	for (i = 0; i < P_ROWS - 1; i++) {
		memcpy(p_vram[i], p_vram[i+1], P_COLS);
		p_flushrow(i);
	}
	memset(p_vram[P_ROWS - 1], ' ', P_COLS);
}

#if 0
void
p_scrolldown(void)
{
	register int i;
	for (i = P_ROWS - 1; i > 0; i--) {
		memcpy(p_vram[i], p_vram[i-1], P_COLS);
		p_flushrow(i);
	}
	memset(p_vram[0], ' ', P_COLS);
}

void
s_put_x_x(char *buf, signed long num, byte len)
{
	register char *dst = buf + (len & 0xF) + (len >> 4);
	register byte i;
	bool sign = false;
	
	if (num < 0) {
		num = -num;
		sign = true;
	}

	for (i = len & 0xF; i; i--) {
		*dst-- = (num % 10UL) + '0'; 
		num /= 10UL;
	}
	
	*dst-- = '.';

	do {
		*dst-- = (num % 10UL) + '0';
		if (dst < buf)
			return;
		num /= 10UL;
	} while (num);
	
	if (sign)
		*dst-- = '-';

	while(dst >= buf)
		*dst-- = ' ';
}

void
p_mvput_x_x(byte x, byte y, signed long num, byte len)
{
	s_put_x_x(p_vram[y] + x, num, len);
	p_move(x + (len & 0xF) + (len >> 4) + 1, y);
	p_flushrow(y);
}
#endif 

void
ports_init(void) /* ve stejnym poradi jako na schematu */
{
#define IN(p,port) IO_DDR##p.bit.D##port = 0;
#define OUT0(p,port) IO_DDR##p.bit.D##port = 1; IO_PDR##p.bit.P##port = 0;
#define OUT1(p,port) IO_DDR##p.bit.D##port = 1; IO_PDR##p.bit.P##port = 1;

#if 0	
	IN  (6, 60);
	IN  (6, 61);
	IN  (6, 62);
	IN  (6, 63);
	IN  (6, 64);
	IN  (6, 65);
	IN  (6, 66);
	IN  (6, 67);
#else
	IO_DDR6.byte = 0;
#endif

	OUT1(5, 55);
	OUT1(4, 40);
	IN  (4, 42);
	IN  (4, 41);
	OUT1(4, 45);
	OUT1(4, 43);
	IN  (4, 44);
	OUT1(4, 46);
	IN  (5, 50);
	OUT1(4, 47);

	OUT1(9, 90);
	IN  (9, 91);
	IN  (9, 92);
	IN  (9, 93);
	IN  (9, 94);
	IN  (9, 95);

	IN  (5, 51);
	IN  (5, 52);
	IN  (5, 53);
	IN  (5, 54);
	IN  (5, 56);
	IN  (5, 57);

#if 0
	OUT0(0, 00);
	OUT0(0, 01);
	OUT0(0, 02);
	OUT0(0, 03);
	OUT0(0, 04);
	OUT0(0, 05);
	OUT0(0, 06);
	OUT0(0, 07);
#else
	IO_PDR0.byte = 0;
	IO_DDR0.byte = 0xff;
#endif

	OUT0(1, 10);
	OUT0(1, 11);
	OUT0(1, 12);
	OUT0(1, 13);
	OUT1(1, 14);
	OUT1(1, 15);
	OUT1(1, 16);
	OUT1(1, 17);

	/* P20 - P26 -- displej, nehrabat */
	/* P27, P62 -- eeprom */
	OUT0(2, 27);
	OUT0(6, 62);

	IO_DDR3.byte = 0xff; IO_PDR3.byte = 0;

	OUT0(7, 70);
	OUT0(7, 71);
	OUT0(7, 72);
	OUT0(7, 73);
	IN  (7, 74);
	OUT1(7, 75); /* podsviceni */
	OUT0(7, 76);
	OUT0(7, 77);

	IO_DDR8.byte = 0xff; IO_PDR8.byte = 0;
#undef IN
#undef OUT0
#undef OUT1
}

