#ifndef _MISC_H_
#define _MISC_H_

/* makro k priprave parametru len u ?_put_x_x */
#define S_PUT_DEC_FRAC(dec,frc) ((dec)<<4 | (frc));
/**
 * @brief do buf hodi cislo num = 123456 ve formatu 1234.56.
 * @param buf -- zacatek bufferu pro ulozeni num
 * @param num -- cislo k prevodu
 * @param len -- horni nibble urcuje delku cele casti,
 * 	spodni nibble delku desetinne casti
 *
 * Na generovani parametru len se muze hodit makro S_PUT_DEC_FRAC,
 * ale jednodussi je nachrlit to primo v hexa (0x43 odpovida xxxx.xxx)
 * Pokud se cislo nevejde, budou oriznuty nejpodstatnejsi cislice.
 * Umi generovat i minus u zapornych cisel.
 *
 * 	cislo bude zarovnane doprava.
 */
void
s_put_x_x(char *buf, signed long num, byte len);

/**
 * @brief chova se stejne jako s_put_x_x, ale provede vypis na displej,
 * nakonec presune kurzor za konec cisla.
 * @param x -- x-ova souradnice na displeji
 * @param y -- y-ova souradnice na displeji
 * @param num -- cislo co prijde na displej
 * @param len -- delka cisla
 */
void
p_mvput_x_x(byte x, byte y, signed long num, byte len);

/** 
 * Odskroluje obrazovku o radek nahoru a na posledni radek hodi txt
 * @param txt text k zobrazeni
 */
void
p_msg(const char *txt);
	
/* Odskroluje displej nahoru a vymaze posledni radek */
void
p_scrollup(void);

/* Odskroluje displej dolu a vymaze prvni radek */
void
p_scrolldown(void);

/**
 * inicializuje vsechny porty tak jak se to ma podle schematu,
 * aby se nepraly s periferiemi.
 */
void
ports_init(void);

#endif /* _MISC_H_ */
