/*
 * ava
 *
 * Power saving funkce
 *
 * Changelog
 *
 * 2006-09-14: ifdef pro CKDM
 */


#include "globals.h"
#include "sleep.h"

volatile bool enable_stop = true;
volatile bool sleeping = false;

#ifdef __CKDM__

#include "panel.h"

void
go_sleep(void)
{
	IO_LPMCR.bit.SLP = 1;
}


void
go_stop(bool hiz)
{
		/* Nez usnu zhasnu si displej */
	IO_PDR7.bit.P75 = 0;
	
	IO_ENIR.byte = 0x00; /* pred zmenami kontrolnich registru treba disablovat */
	IO_ELVR.word = 0x0;  /* low level */
	IO_EIRR.byte = 0x0;  /* vynuluju cause registr */
#if 0
	if (!hiz)
		p_low_power_prepare();
#endif
	IO_ENIR.byte = 0xff; /* muzeme enablovat */


	IO_LPMCR.bit.SPL = hiz ? 1 : 0;
	IO_LPMCR.bit.STP = 1;
}


void 
set_pll(bool pll)
{
	/*
	 * az to bude potreba, brat ohled na ppg ktery bezej podle machine clock
	 * (jmenovite ppg6/7 ktery dava hodiny UARTu 1 */
	
	if (pll) {
		IO_CKSCR.byte=0xFD;
		IO_CKSCR.bit.MCS=0;
		while (IO_CKSCR.bit.MCM);
	} else {
		IO_CKSCR.bit.MCS=1;
		while (!IO_CKSCR.bit.MCM);
	}
}

#else /* neni CKDM */

void go_sleep(void) { }
void go_stop(bool hiz) { }
void set_pll(bool pll) { }

#endif 

