;==========================================================================
; startup for small model
;--------------------------------------------------------------------------
		.PROGRAM	start
		.TITLE		start
;--------------------------------------------------------------------------
; external declaration of symbols
		.EXPORT		__start
		.EXPORT		__exit
		.IMPORT		_main
;--------------------------------------------------------------------------
; definition to stack area
		.SECTION  STACK, STACK, ALIGN=2
		.RES.B		1100
SSTACK_TOP:
;--------------------------------------------------------------------------
; definition to start address of data, const and code section

		.SECTION	DIRDATA,  DIR,	    ALIGN=2
DIRDATA_S:
		.SECTION	DIRINIT,  DIR,	    ALIGN=2
DIRINIT_S:
		.SECTION	DATA,	  DATA,	    ALIGN=2
DATA_S:
		.SECTION	INIT,	  DATA,	    ALIGN=2
INIT_S:
		.SECTION	LIBDATA,  DATA,	    ALIGN=2
LIBDATA_S:
		.SECTION	LIBINIT,  DATA,	    ALIGN=2
LIBINIT_S:
		.SECTION	DIRCONST, DIRCONST, ALIGN=2
DIRCONST_S:
		.SECTION	DCONST,	  CONST,    ALIGN=2
DCONST_S:
		.SECTION	CONST,	  CONST,    ALIGN=2
CONST_S:
		.SECTION	LIBDCONST,CONST,    ALIGN=2
LIBDCONST_S:

;--------------------------------------------------------------------------
; code area
		.SECTION	CODE,	  CODE,	    align=2

        .section startup, code, align=2
__start:
;--------------------------------------------------------------------------
                and ccr,#0
                or ccr,#0x20
		MOV	ILM, #0
		MOV	RP, #0 ; set register bank is 0
		MOV	A, #BNKSYM SSTACK_TOP
		MOV	SSB, A
		MOVW	A, #SSTACK_TOP
		MOVW	SP, A
;--------------------------------------------------------------------------
		MOV	A, #PAGE DIRDATA_S ; set direct page register
		MOV	DPR, A
;--------------------------------------------------------------------------
; copy initial value *CONST section to *INIT section

#macro		ICOPY	src_addr, dest_addr, src_segment
		MOV	A, #BNKSYM \src_addr
		MOV	ADB, A
		MOV	A, #BNKSYM \dest_addr
		MOV	DTB, A
		MOVW	RW0, #SIZEOF (\src_segment)
		MOVW	A, #\dest_addr
		MOVW	A, #\src_addr
		MOVSI	DTB, ADB
#endm
		ICOPY	DIRCONST_S, DIRINIT_S, DIRCONST
		ICOPY	DCONST_S,   INIT_S,    DCONST
		ICOPY	LIBDCONST_S,LIBINIT_S, LIBDCONST
;--------------------------------------------------------------------------
; zero clear of *VAR section
#macro		FILL0	src_addr, src_segment
		MOV	A, #BNKSYM \src_addr
		MOV	DTB, A
		MOVW	RW0, #SIZEOF (\src_segment)
		MOVW	A, #\src_addr
		MOVN	A, #0
		FILSI	DTB
#endm
		FILL0	DIRDATA_S, DIRDATA
		FILL0	DATA_S,	   DATA
		FILL0	LIBDATA_S, LIBDATA

;--------------------------------------------------------------------------
; set data bank register
		MOV	A, #BNKSYM DATA_S
		MOV	DTB, A
;--------------------------------------------------------------------------
; call main routine
        mov ilm,#7
        or ccr,#0x60
        jmpp __main
                .section CODE
__main:
		CALL	_main
__exit:
		JMPP	__exit

		.SECTION reset, data, LOCATE=0xFFFFE0
		.data.l	__start
		.END	__start
;----------------------------------------------------------------------------

