#include "globals.h"
#include "timer.h"
#include "buzzer.h"
#include "panel.h"

/*
 * Changelog:
 * 2006-10-04: Nyni je zhaseni displeje volitelne.
 * 2006-10-24: Pridano usleep()
 */

volatile uint32	jiffies = 0;

/* TODO urcite spi prinejmensim usec, ale v teto implementaci pravdepodobne nekolikrat dele. */
void
usleep(uint32 usec)
{
	uint32 i, iters = usec * (uint32)(1000/62);
	for(i = 0; i < iters; i++)
		__wait_nop(); /* jedno __wait_nop trva 62.5 ns na 16MHz */
}

uint32 
get_jiffies(void)
{
	return jiffies;
}

void
jsleep(uint32 n)
{
	register uint32 tilljiffies = jiffies + n;
	bool es = enable_stop;
	enable_stop = false;
	while(tilljiffies > jiffies)
		go_sleep();
	enable_stop = es;
}

void
support_init(void)
{

	IO_PPGC01.word		&= ~0x8080; /* PPG enable - vypneme to. */
	
	IO_PPGC01.bit.PE00	= 0; /* PPG ch0 output pin enable */
	IO_PPGC01.bit.PE10	= 0; /* PPG ch1 output pin enable */
	IO_PPGC01.bit.PIE0	= 1; /* PPG ch0 interrupt enable */
    IO_PPGC01.bit.PIE1	= 0; /* PPG ch1 interrupt enable */
	IO_PPGC01.bit.MD	= 0; /* 0 -- independent mode, 3 -- 16bit mode */

	/* BACHA, chyba v manualu co se tyce 
	 * casovych zakladen PCM a PCS, viz corrections k manualu ! 
	 * mam podezreni ze spatne jsou predevsim ty corrections :-) */
	IO_PPG01.bit.PCM	= 7; /* casova zakladna ch0 */
	IO_PPG01.bit.PCS	= 7; /* casova zakladna ch1 */
	
		/* bacha, kdyz v 16tibitovem modu pisu do PRL, MUSIM vzdy
		 * zapsat nejprve do ch0 a pak do ch1. Musim provest vzdy OBA
		 * zapisy !! (strana 174 HM dole) */
	
#if		defined(XTAL80000)
	IO_PRL[0].word		= 0x9B9B;
#elif	defined(XTAL73728)
	IO_PRL[0].word		= 0x9090;
#else
#error Neznamy krystal (makro XTAL*)
#endif
	
	IO_ICR05.bit.IL		= 5;

	IO_PPGC01.bit.PEN0	= 1; /* PPG enable - odstartujem to. */
}


__interrupt void
support_int(void)
{
	register byte keyb_row = jiffies & 3;
	
	p_setled(3, IO_PDR3.bit.P34 == 0 ? LED_GREEN : LED_RED); /* XXX na treti ledce ukazuje GPIB_INRFD */
	if (sleeping)
		return;
		/* nastaveni masky klavesnice je na zacatku a cteni na konci, asi tam
		 * je nejaka kapacita protoze kdyz to bylo tesne za sebou tak to
		 * vracelo blby hodnoty. */
	IO_PDR7.byte = IO_PDR7.byte&0xf0 | 0xf7>>keyb_row & 15;

	IO_PPGC01.bit.PUF0	= 0; /* vycistim underflow */
	IO_PPGC01.bit.PUF1	= 0; /* vycistim underflow */

	jiffies++;


	KeybCnt && KeybCnt--;

#ifdef DISPLAY_SAVING_TIMEOUT
	if (display_saving_timeout && !--display_saving_timeout)
		IO_PDR7.bit.P75 = 0; /* vypnu podsviceni */
#endif 

	keyb_row = keyb_row+1 & 3;
	key_pressed |= (KeybScan[keyb_row] = IO_PDR9.byte<<2&0xf0 | IO_PDR5.byte>>1&15);
}
