/*
 * ava
 *
 * timer.c pro windows
 *
 * Changelog
 *
 * 2006-09-14: Zalozeno
 */

#include "globals.h"
#include "timer.h"

#include <windows.h>

 /* Nekorektni rychla verze, spravny postup se da implementovat podle
  *
  * http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/systemtime_str.asp
  *
  * ted se resetuje kazdy den na nulu.
  */
uint32
get_jiffies(void)
{
	SYSTEMTIME systemtime;

	GetSystemTime(&systemtime);

	return 
		((uint32)systemtime.wMilliseconds) * JIFRATE / 1000 +
		((uint32)systemtime.wSecond) * JIFRATE +
		((uint32)systemtime.wMinute) * JIFRATE * 60 +
		((uint32)systemtime.wHour) * JIFRATE * 3600;
}

void
jsleep(uint32 n)
{
	Sleep(n * 1000 / JIFRATE);
}
