#ifndef _TIMER_H_
#define _TIMER_H_

/* Changelog
 * 2006-10-24: Pridano usleep()
 */

#include "globals.h"
#include "sleep.h"

#define JIFRATE	100	/* frekvence jiffies (priblizne) [Hz] */

/* jako casovac a generator preruseni vyuzivam
 * ppg (programmable pulse generator), ma jednu vyhodu oproti reload timeru --
 * je u nej mozne jako casovou zakladnu vyuzivat primo krystal/512, je tedy
 * nezavisly na tom zda jedu v main clock mode nebo v nejakem pll. */

#ifdef __CKDM__

/** jiffies bezi vzdy zhruba na JIFRATE Hz (v ramci moznosti presnosti ppg) */
extern volatile uint32 jiffies; /* kvuli zpetne kompatibilite a rychlosti */

/**
 * obsluzna rutina supportu(viz nize) */
__interrupt void
support_int(void);

#endif 

void
usleep(uint32 usec);

/* Vraci hodnotu jiffies */
uint32
get_jiffies(void);

/* support se stara o veci ktere je treba periodicky opakovat, 
 * ale nemaji moc vysokou
 * prioritu -- skenovani klavesnice, zhasinani displeje, inkrementace jiffies
 * apod. je spousteny z ppg0/1 kanalu 0 */

/**
 * support_init -- inicializace supportu (viz vyse) */
void
support_init(void);

/** Ceka n jiffies */
void
jsleep(uint32 n);
#endif /* _TIMER_H_ */
