#ifndef _DEVICES_H_
#define _DEVICES_H_

#include "globals.h"

enum cmd_err {
	cmd_ok = 0, /* Zadna chyba */
	cmd_terminated = 1,
	cmd_timeout = 2, 
	cmd_invalid = 3,
	cmd_comm = 4,
	cmd_wait = 5,
	cmd_local = 6, 
};

#define DEV_LUX		(1 << 0)	/* luxmetr */
#define DEV_STUL	(1 << 1)	/* stul */
#define DEV_RAM		(1 << 2)	/* rameno */

/* Init vsech zarizeni. Luxmetru se nastavi nejvyssi rozsah, stul a rameno
 * najedou do referencni polohy. 
 * Promenna devices (na tu se odvolava fce devices_present() se naplni podle
 * toho ktera zarizeni jsou OK.
 */
void
devices_init(void);

/* Prostouchne si sbernice a zjisti, ktera zarizeni jsou pripojena a reaguji.
 * Promenna devices (na tu se odvolava fce devices_present() se naplni podle
 * toho ktera zarizeni jsou OK.
 */
void
devices_find(void);

/* vraci OR-nute DEV_*, 1 znamena ze zarizeni bylo korektne nalezeno */
byte
devices_present(void);

/* Pokud je local true, vsechna zarizeni se nastavi tak aby sla
 * ovladat lokalne. pokud je false, lokalni ovladani se zakazuje. */
void
devices_local(bool local);

/* Vraci true, pokud jsme zrovna v lokalnim rezimu. */
bool
devices_islocal(void);

#endif /* _DEVICES_H_ */
