#ifndef _UI_H_
#define _UI_H_

/* Typovaci vzdalenost, take krok po kterem se zaokrouhluje hodnota na displeji. */
#define TYPE_DISTANCE 50

/*
 * TODO kecy, davno neplati
 *
 * Pri spusteni CKDM si pomoci devices_init() zjisti, ktera vsechna zarizeni
 * jsou pripojena a prislusne vyplni promenou devices.  Zaroven se CKDM prepne
 * do lokalniho rezimu, tj. vsechna zarizeni jdou ovladat z pultu. Pokud prijde
 * od PC prikaz C_REn, pomoci fce devices_local(false) se vsechna zarizeni
 * prepnou do vzdaleneho rezimu, zadne nejde ovladat. Pokud ovsem uzivatel na
 * CKDM stiskne prislusne tlacitko, zarizeni se opet prepnou do lokalniho
 * rezimu, CKDM odpovida PC na vsechny prikazy odpovedi cmd_local. Jsou prave
 * dve moznosti jak se opet dostat do vzdaleneho rezimu, bud prikazem z PC
 * C_REn nebo stiskem urceneho tlacitka na CKDM.
 *
 * Spusteni CKDM ---(init)--> local ---(C_REn nebo tlacitko)---> remote
 *                                _                                 |
 *                               |\________(tlacitko)______________/
 */

#include "globals.h"

enum cmd_err {
	cmd_ok = 0, /* Zadna chyba */
	cmd_terminated = 1,
	cmd_timeout = 2, 
	cmd_invalid = 3,
	cmd_comm = 4,
	cmd_wait = 5,
	cmd_local = 6,
	cmd_stop_pressed = 7, /* Stisknuta STOPka */
	cmd_illegal_movement = 8 /* pohyb mimo rozsah */
};

struct arm_program {
	int32 dist;
};

extern struct arm_program arm_programs[4];

const char *
cmd_strerr(enum cmd_err);

void
ui(void);

#endif /* _UI_H_ */
